class link {
	int	index;
	link *	next;
	float	prob;
	friend 	Bigram;
};

class Bigram {
	char	Tokens[MAXSYMBOLS][MAXSYMLEN];
	int	iTokens;
	link*  list[MAXSYMBOLS];
	Grammar *g;
	void	clear_list(link * lp);
	int		iInputLen;
	Symbol	*InputTokens[MAX_SENTENCE_LEN];
public:
	void    tokenizer(char*& inp);
	void	add_to_follow(int,int,float);
	float 	bigram_parse();
	float	get_follow_prob(int,int);
	float get_bigram_followpair(Symbol * word1,Symbol * word2);
	int 	get_bigram_vector(Symbol * word,char ** followarray, float *probs);
	int 	get_bigram_vector_new(Symbol * word, float *probs);
	//int 	FilterFollow(int *, int ,int *);
	        Bigram(Grammar *g);
	        ~Bigram();
};

