// mtest.C
#include "mtest.H"
#include <iostream.h>

Thing::Thing()  {
//    cout << "Thing()=" << this << endl;
}

char *Thing::Type() {
    return "(Thing)";
}

ThingA::ThingA()  {
//    cout << "ThingA()=" << this << endl;
}

char *ThingA::Type() {
    return "A";
}
char *ThingA::Type2() {
    return Type();
}

ThingB::ThingB()  {
//    cout << "ThingB()=" << this << endl;
}

char *ThingB::Type() {
    return "B";
}
char *ThingB::Type2() {
    return Type();
}

ThingC::ThingC()  {
//    cout << "ThingC()=" << this << endl;
}

char *ThingC::Type() {
    return "C";
}
char *ThingC::Type2() {
    return Type();
}

System::System(void) {
//    cout << "System()=" << this << endl;
    str = 0;
    thingA = 0;
    thingB = 0;
    thingC = 0;
}

System::~System(void) {
//    cout << "~System(" << this << ")" << endl;
    if(str)	delete [] str;
    if(thingA)	delete thingA;
    if(thingB)	delete thingB;
    if(thingC)	delete thingC;
}

//#include "mtest_cdl.H"

void System::putString(char *s)	
{ 
//    cout << (void *)s << endl << flush; 
    str = s; 
}

void System::putString2(char *s)	
{ 
//    cout << (void *)s << endl << flush; 
    str = s; 
}

Thing* System::someThing(int arg)  {
    if(arg&1)  {
	if(thingA==0)	thingA = new ThingA;
	return thingA;
    } else {
	if(thingB==0)	thingB = new ThingB;
	return thingB;
    }
}

Thing* System::cThing(void)  {
    return new ThingC;
}

ThingC& System::cThing2(void)  {
    if(thingC==0)	thingC = new ThingC;
    return *thingC;
}

char* System::getString2(void) {
    return str;
}

// slot tests
int SlotTest::testClassSlot = 0;

// Obj return tests

int ReturnableObj::count = 0;	// static class variable
