/*
** $Header: /u/spert/src/intvec/nv/RCS/vecred.c,v 1.1 1995/09/08 22:44:45 davidj Exp $
**
** Reduction operations - the quick and easy way
*/

#include <intv-config.h>
#include <stddef.h>
#include <intv-defs.h>
#include <intv-scansrc.h>

#ifdef DECL_nv_sum_vi32_i32
intv_int32_t nv_sum_vi32_i32(size_t len, const intv_int32_t* in);
#endif

#ifdef DEFN_nv_sum_vi32_i32

intv_int32_t
nv_sum_vi32_i32(size_t len, const intv_int32_t* in)
{
    size_t i;
    intv_int32_t res = 0;

    for (i=0; i<len; i++)
	res += *in++;

    return(res);
}

#endif
