/*
    $Header: /u/drspeech/src/pfile_utils/RCS/error.h,v 1.1 1997/06/19 02:30:14 bilmes Exp dpwe $
  
    Simple fatal error function.
    Jeff Bilmes <bilmes@cs.berkeley.edu>
*/



#ifndef ERROR_H
#define ERROR_H

// Bool doesn't belog here, but it avoids putting it in other files
#ifndef HAVE_BOOL
#ifndef BOOL_DEFINED
enum bool { false = 0, true = 1 };
#define BOOL_DEFINED
#endif
#endif

#ifndef EXIT_SUCCESS
#define EXIT_SUCCESS (0)
#endif
#ifndef EXIT_FAILURE
#define EXIT_FAILURE (1)
#endif

void error(char *format, ...);

#endif
