#include "grammar.h"

static Grammar g("ss",0);
int News = 0;
int Deletes = 0;
int NodeDeletes = 0;
int NodeCreates = 0;
int ArcNews = 0;
int ArcDeletes = 0;
int RuleNews = 0;
int RuleDeletes = 0;
int SymbolNews = 0;
int SymbolDeletes = 0;

main(int argc, char *argv[])
{
	char buf[200];
	int i;
	int num;

	g.ReadFile("berp.grammar");

	if (argc == 2) 
		num = atoi(argv[1]);
	else
		num = 10;

	for (i=0;i < num;i++) {
		g.GenerateRandomSentence();
		g.GetSentence(buf);
		cout << buf << flush;
		cout <<  "\n" << flush;
	}
	exit(0);
}
	

void *operator new(size_t sz)
{
	++News;
	return malloc(sz);
}

void operator delete(void *p)
{
	++Deletes;
	free((char *)p);
}

	
