#include <stdio.h>
#include <fcntl.h>

int
main(int ac, char **av)
{
	int fd;
	char c;

	if (ac < 2) {
		fprintf(stderr, "Usage %s: %s filename\n", av[0], av[0]);
		exit(1);
	}

	if (-1 == (fd = open(av[1], O_WRONLY | O_CREAT, 022))) {
		perror(av[1]);
		exit(1);
	}

	while (1 == read(0, &c, 1)) {
		if (1 != write(1, &c, 1)) {
			perror("tee: write to stdout");
			exit(1);
		}
		if (1 != write(fd, &c, 1)) {
			perror("tee: write to file");
			exit(1);
		}
	}
}
