.de Sh
.br
.ne 5
.PP
\fB\\$1\fR
.PP
..
.de Sp
.if t .sp .5v
.if n .sp
..
.               \" Path Name
.               \"      uses Courier fonts for V4.0
.de PN
.ie t \&\f(CB\\$1\f(NR\\$2
.el \fI\\$1\fP\\$2
..
.		\" The following macros added by dpwe for Ultrix 4..
.               \" Manual section reference
.               \"      uses Courier fonts for V4.0
.de MS
.ie t \&\f(CB\\$1\f(NR(\\$2)\\$3
.el \fI\\$1\fP(\\$2)\\$3
..
.de EX		\" Begin Example
.ie \\n(.$ .nr EX \\$1n
.el \{\
.	ie n .nr EX 0n
.	el .nr EX 0n
.\}
.in +\\n(EXu
.if n .sp 1
.if t .sp .5v
.nf
.CW
.ft CB
..
.de EE		\" End example
.in -\\n(EXu
.fi
.}f             \" restore basic text attributes
.if n .sp 1
.if t .sp .5v
..
.TH OLFNORMS 1 "1999 nov 08" dpwe   \" $Header: /u/drspeech/src/ffwd/RCS/olfnorms.man,v 1.2 1999/11/09 05:15:20 dpwe Exp $
.SH NAME
olfnorms - calculate a norms file for online features
.SH SYNOPSIS
\fBffwd
[\-width \fIw\fB]
[\-ifile \fIinFile\fB]
[\-ofile \fIoutFile\fB]
\fR
.SH DESCRIPTION
.PN olfnorms
is a small and fast pure-C program that reads through a file of 
features in 
.MS online_ftrs 5
format, and calculates their means and variances, writing the 
output in the same format as that written by 
.MS qnnorm 1
(which is actually the means of each column followed by the 
inverse of the standard deviations of each column).
This program is written as a companion to 
.MS ffwd 1
for calculating normalization files on-the-fly for unnormalized 
data.  The files it writes are suitable as -nfile inputs to 
.MS ffwd 1 .
.SH OPTIONS
.TP
.B -width \fIw\fR
The number of features in each frame of the input online feature 
format stream (this is not detectable from an 
.MS online_ftrs 5
stream).
.TP
.B -ifile \fIname\fR
Name of the input 
.MS online_ftrs 5 
stream.  "-" means to read from standard input.
.TP
.B -ofile \fIname\fR
Name for the output norms file.  "-" means to write to standard output.
.SH BUGS
Tested rather little.  Presumably ignores segment breaks in input.
.SH SEE ALSO
.MS ffwd 1
.SH AUTHOR
Dan Ellis, 
.B dpwe@icsi.berkeley.edu 
