#
# testimg.tcl
#
# Code to test the gd-farray interface
# 
# 1996nov27 dpwe@icsi.berkeley.edu
# $Header: /n/yam/da/dpwe/src/tcl/gd1.2/RCS/testimg.tcl,v 1.1 1998/03/04 02:45:55 dpwe Exp $

#load /u/dpwe/lib/sun4-sunos5/libtclsound.so
#load ./libgdtcl.so
lappend auto_path /u/dpwe/sun4-sunos5/lib
lappend auto_path .
package require GdTcl

# Make sure it's loaded
catch {gd foo}

floatArray fa
fa Load "[file dirname [info script]]/fa.dat"
#fa normcols
for {set i 0} {$i < [fa Cols]} {incr i} {
    set r [fa ColRef $i]
    set m [$r Max]
    if {$m > 0.0} {
	$r Scale [expr 1.0/$m]
    }
}
set cmap ""
set im [gd create 260 50]
for {set i 0} {$i<20} {incr i} {lappend cmap [gd color new $im [expr $i*12] [expr $i*12] 0]}
gd arrayimage $im $cmap 10 5 fa

set out [open t2.gif w]
gd writeGIF $im $out
close $out
#exec mv t2.gif /u/dpwe/public_html
exec xv t2.gif
exec rm t2.gif
